<?php

/*

CMSimple Guestbook plugin
 2006-2007 - Joachim Barthel - www.qualifire.de/cmsimple/en
---------------------------------------------------------------------
Disclaimer:   No warranties at all, use on your own risk !
---------------------------------------------------------------------
Requirements: - CMSimple 2.5 is installed and running.
              - The plugin loader, version 1.0 beta 5 from  
                cmsimpleplugins.svarrer.dk is installed and working!
                -or-
              - The plugin loader, version 2.0 beta 9 from
                internet-setup.de/abdj_download/index.php is installed and working!  
---------------------------------------------------------------------
Feedback to:  jbarthel@qualifire.de
---------------------------------------------------------------------

Version 0.1 beta 0  (23. Feb. 2006)

Version 0.1 beta 1  (26. Feb. 2006)
  - Support for multilingual use
  - Enhancements of display
  - Support of CrLf in message
  - Storing of IP address

Version 0.1 beta 2  (14. March 2006)
  - No double entries on refresh
  - Text-Captcha for spam protections
  - Using CSS for displaying the entries

Version 0.1 beta 3  (19. March 2006)
  - Display of EMAIL and WEBSITE switchable
  - Option for removing HTML and SCRIPT elements
  - Full CSS support for colors
  - Splitting into pages

Version 0.1 beta 4  (24. March 2006)
  - support of french language (thanx to Gerd)
  - constant width of name column
  - Info-Mail for new entries
  - ignores empty lines

Version 0.1 beta 5a  (18. April 2006)
  - support of apostrophe (' and ")
  - checking of mandatory field (incl. white spaces)
  - beautified info email
  - enhanced Captcha
  - thanks email
  - switching on/off
  - support for php w/o bcmath

Version 0.1 beta 5b  (19. April 2006)
  - enhanced header() for MS IIS 

Version 0.1 beta 5c  (20. April 2006)
  - display of PHP errors (=white page problem)

Version 0.1 beta 5d  (30. April 2006)
  - enhanced handling of title field
  - support of slovak language (thanx to Martin Sereday)

Version 0.6 beta (September 2006)
  - new folder 'images' for the bitmaps
  - all functions renamed to gb_nnnnnnn to avoid conflicts with other plugins
  - function gb_Version() added
  - support of danish language (thanx to Per Kongebro)
  - support of finish language (thanx to Ahti Kurki)
  - support of dutch language (thanx to Gerd Xhonneux)
  - support of portuguese language (thanx to JoaoVr)
  - import function for original CMSimple guestbook
  - avoid error on empty lines in guestbook file
  - support of multiple guestbooks per language
  - new CSS file for green colored websites

Version 0.6a beta (10. October 2006)
  - corrected captcha (pure ascii)
  - another fix for empty guestbooks

Version 0.7 beta (26. December 2006)
  - corrected config.php (spam_words and show_creator were missing)
  - predefined guestbooks for DA, FI, IT, NL, PT, SK added
  - Quick link in info e-mail
  - Missing guestbook file will be created by plugin
  - Link to QualiFIRE now optionally
  - support of italian language (thanx to Sandro Cavalieri Foschini)
  - support of norwegian language (thanx to Tobias Michel)
  - enhanced page navigation (esp. for many pages)
  - options for showing e-mail, website and ip-address
  - e-mail can optionally be mandatory
  - simple encrypting of e-mail addresses (thanx to Eric Levermann)
  - enhanced formatting of input fields through css support
  - removed old entries from css files
  - corrected display of first entry/last page (in some cases not displayed)
  - checking for correct e-mail
  - storing of ip address now optionally
  - protection of the content folder with .htaccess
  - adjustable width of message textarea
  - option for lower case captcha
  - enhanced captcha transfer
  - support of smileys (multicolor icons & insert function)
  - reorg function for datafile
  - info e-mail as html mail

Version 0.7a beta (03. January 2007)
  - corrected french language file (thanx to BoB)

Version 0.8 beta (20. March 2007)
  - block list for IP addresses
  - block words against spam
  - block list for countries (based on www.phptutorial.info/iptocountry)
  - optionally one guestbook for all languages
  - support of hungarian language (thanx to Zsolt Kdas)
  - correction of error on checking e-mail (when it is not mandatory), thanx to Flo
  - config text "blocked_words" used instead of "spam_words"
  - support of &print mode of cmsimple (no page splitting)
  - optional quarantine time for new messages

Version 0.8a beta (1. April 2007)
  - error correction for single ip addresses in list of blocked ip'S
  
Patch 0.8b beta (28. June 2008)
  - changed captcha for blocking "doris"
  
Patch 0.8c (05. June 2008)
  - additional graphical captcha, again because of "doris" spam

### Mod v0.1 by Pinoccio (Oct. 2010) ###
  - input form redesign (table layout) + css
  - captcha picture modified
  - added Cancel button in form  
  - messages from Admin (identified by special qualifier in name field) are highligted
  - added simple bbcode support + hints page (multilanguage support)
  - limit max. message size (characters) + counter of remaining characters
  - guestbook rules hint (link to a hint page, multilanguage support)
  - optional hint to a FAQ page (to reduce repeated questions)
  - some html validity problems solved
  - oher minor changes...
*/

require_once("include/bbcode.php");

function gb_Version() {
   return "0.8c beta";
}

function gb_ModVersion() {
   return "v0.1";
}


function gblist($gb_filename) {
   GLOBAL $su, $sl, $plugin_cf, $plugin_tx, $pth, $plugin;

   if (!isset($gb_filename)) $gb_filename = "guestbook";
   $t = "";
   $gbname = isset($_POST['gbname']) ? $_POST['gbname'] : $_GET['gbname'];
   $gbemail = isset($_POST['gbemail']) ? $_POST['gbemail'] : $_GET['gbemail'];
   $gbwebsite = isset($_POST['gbwebsite']) ? $_POST['gbwebsite'] : $_GET['gbwebsite'];
   $gbtitle = isset($_POST['gbtitle']) ? $_POST['gbtitle'] : $_GET['gbtitle'];
   $gbmessage = isset($_POST['gbmessage']) ? $_POST['gbmessage'] : $_GET['gbmessage'];
   $gbpage = isset($_POST['page']) ? $_POST['page'] : $_GET['page'];
   $gboption = isset($_POST['option']) ? $_POST['option'] : $_GET['option'];
   if (intval($gbpage)==0) $gbpage=1;
   
   if($gboption != '')
     return gb_returnContents($gboption);

   $plugin = basename(dirname(__FILE__),"/");
   if(eregi("true",$plugin_cf['gbook']['common_guestbook'])) {
      $gbfile = $pth['folder']['plugins'].$plugin."/content/" . $gb_filename . ".txt";
   } else {
      $gbfile = $pth['folder']['plugins'].$plugin."/content/" . $gb_filename . "_".$sl.".txt";
   }
   $imgpath = $pth['folder']['plugins']."gbook/images/";
   $gb_nlines = gb_CountLines($gbfile);
   if(eregi("true",$plugin_cf['gbook']['captcha'])) {
      $gbcc = isset($_POST['gbcc']) ? $_POST['gbcc'] : $_GET['gbcc'];
   } else {
      $gbcc = gb_CreateTextCaptcha($gb_nlines);
   }

   error_reporting(E_ALL);

   
   $abortcode = 0;
   if ($gbcc <> gb_CreateTextCaptcha($gb_nlines)) $abortcode = $abortcode | 1;
   if ((gb_chkBlockedWords($gbtitle) || gb_chkBlockedWords($gbmessage)) == true) $abortcode = $abortcode | 2;
   if (gb_chkBlockedIPs($_SERVER["REMOTE_ADDR"]) == true) $abortcode = $abortcode | 4;
   if (gb_chkBlockedDomains($_SERVER["REMOTE_ADDR"]) == true) $abortcode = $abortcode | 8;
   if (gb_chkBlockedCountries($_SERVER["REMOTE_ADDR"]) == true) $abortcode = $abortcode | 16;
   if (strlen($gbmessage) > $plugin_cf['gbook']['message_max_chars']) $abortcode = $abortcode | 32;
   

   if($gbname && $gbmessage) {
      
      if ($abortcode == 0) {

         $gbwebsite = eregi_replace("http://","",$gbwebsite);
         $gbname = gb_RemoveHtml($gbname);
         $gbemail = gb_RemoveHtml($gbemail);
         $gbwebsite = gb_RemoveHtml($gbwebsite);
         $gbtitle = str_replace(";",",", $gbtitle);
         $gbtitle = gb_RemoveHtml($gbtitle);

         if(eregi("true",$plugin_cf['gbook']['remove_html'])) {
            $gbmessage = gb_RemoveHtml($gbmessage);
         }
         $gbmessage = gb_conv2Smileys($gbmessage);

         $gbmessage = str_replace(chr(13).chr(10),"<br>",$gbmessage);
         $gbmessage = str_replace(chr(13),"<br>",$gbmessage);
         $gbmessage = str_replace(chr(10),"<br>",$gbmessage);
         $gbmessage = str_replace(";",",",$gbmessage);
         $gbipaddr = eregi("true",$plugin_cf['gbook']['store_ip_addr']) ? $_SERVER["REMOTE_ADDR"] : "";

         if (!$fp = fopen($gbfile, 'a+')) {
            $t .= "<br><hr>ERROR: Cannot open file ($gbfile)<hr><br>";
         } else {
            $gbentry = "\n" . $gbname .";". $gbemail .";". $gbwebsite .";". date($plugin_cf['gbook']['time_format']) .";". date($plugin_cf['gbook']['date_format']) .";". $gbtitle .";". $gbmessage .";". $gbipaddr .";". mktime();
            if (fputs($fp,$gbentry) == FALSE)
               $t.="<br>ERROR: Cannot write to file ($gbfile)";
            fclose($fp);
            // eregi("^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[_a-z0-9-]+(\.[_a-z0-9-]+)*(\.([a-z]{2,4}))+$",$gbemail)
            if (!$plugin_cf['gbook']['info_mail']=="") {
               $mailbody = $gbname . " " . $plugin_tx['gbook']['txt_email_wrotes'] . ":<br>";
               $mailbody .= str_repeat("-", strlen($mailbody)) . "<br><br>";
               if (!$gbtitle == "") $mailbody .= $gbtitle . "<br><br>";
               $mailbody .= $gbmessage ."<br><br>";
               $gblink = "http://" . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'] . "?" . $_SERVER['QUERY_STRING']; 
               $mailbody .= "<a href=\"$gblink\">$gblink</a><br>";
               @mail(
                  $plugin_cf['gbook']['info_mail'],
                  "NEW: ".$gbtitle,
                  $mailbody,
                  "From: Gbook_".$sl."@{$_SERVER['SERVER_NAME']}\r\n"
                  ."Content-Type: text/html\r\n"
                  ."Content-Transfer-Encoding: 8bit/html\r\n"
                  ."X-Mailer: PHP/" . phpversion());
            }
            if (eregi("true",$plugin_cf['gbook']['thank_mail']) && (!$gbemail == "")) {


               $mailbody = sprintf(eregi_replace("<br>","\n",$plugin_tx['gbook']['txt_thankmail_body']), $gbname, $_SERVER['SERVER_NAME']) . "\n";
               @mail(
                  $gbemail,
                  $plugin_tx['gbook']['txt_thankmail_subject'],
                  $mailbody,
                  "From: ".$plugin_cf['gbook']['thank_sendfrom']."\r\n"
                  //."Reply-To: ".$plugin_cf['gbook']['thank_sendfrom']."\r\n"
                  ."X-Mailer: PHP/" . phpversion());

            }

            header("Location: http://" . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'] . "?" . $_SERVER['QUERY_STRING']); exit;
         }
      } else {
         
         $t .= "<br/><div style=\"border: 1px solid red;padding:2px;\"><ul>";
         if (($abortcode & 1) == 1) $t .= "<li>" . $plugin_tx['gbook']['txt_wrong_captcha'] . "</li>";
         if (($abortcode & 2) == 2) $t .= "<li>" . $plugin_tx['gbook']['txt_spam_found'] . "</li>";
         if (($abortcode & 4) == 4) $t .= "<li>" . $plugin_tx['gbook']['txt_blocked_ip'] . "</li>";
         if (($abortcode & 8) == 8) $t .= "<li>" . $plugin_tx['gbook']['txt_blocked_domain'] . "</li>";
         if (($abortcode & 16) == 16) $t .= "<li>" . $plugin_tx['gbook']['txt_blocked_country'] . "</li>";
         if (($abortcode & 32) == 32) $t .= "<li>" . $plugin_tx['gbook']['txt_message_limit'] . " (max. " . $plugin_cf['gbook']['message_max_chars'] . ")</li>";
         $t .= "</ul></div>";
      }
   }

   $t .= "<!-- QualiFIREs Guestbook >>GBook<< Code starts here -->\n<div><br>\n";

   $t .= "<script language=\"javascript\" type=\"text/javascript\">\n";
   $t .= "function gb_showDetail(iNum) {\n";
   $t .= "var IDName;\n";
   $t .= "IDdetail = 'detail' + iNum;\n";
   $t .= "IDanchor = 'anchor' + iNum;\n";
   $t .= "if (document.getElementById(IDdetail).style.display.indexOf('block') == -1) {\n";
   $t .= "document.getElementById(IDdetail).style.display = \"block\";\n";
   $t .= "document.getElementById(IDanchor).style.display = \"none\";\n";
   if (eregi("true",$plugin_cf['gbook']['captcha'])) {
      $t .= "document.gbook.gbcc.focus();\n";
   } else {
      $t .= "document.gbook.gbname.focus();\n";
   }
   $t .= "} else {\n";
   $t .= "document.getElementById(IDdetail).style.display = \"none\";\n";
   $t .= "document.getElementById(IDanchor).style.display = \"block\";\n";
   $t .= "}\n";
   $t .= "}\n";

   if (!eregi("true",$plugin_cf['gbook']['image_captcha'])) {
      $t .= "function gb_showCC(){\n";

      $t .= "return deRot(unescape(\"";
      $tcc = gb_CreateTextCaptcha($gb_nlines);
      for ($i=0; $i<6; $i++)
         $t .= '%'. dechex(ord(gb_rot13(substr($tcc,$i,1))));
      $t .= "\"));\n";
      $t .= "}\n";
   
      $t .= "function deRot(sCode) {\n";
      $t .= "var key =\"ABCDEFGHIJKLMNOPQRSTUVWXYZ\";\n";
      $t .= "txtRot = new String()\n";
      $t .= "for(var i = 0; i < sCode.length; i++) {\n";
      $t .= "var codechar	= sCode.substring(i, i + 1)\n";
      $t .= "var pos = key.indexOf(codechar.toUpperCase())\n";
      $t .= "if(pos >= 0) {\n";
      $t .= "pos = (pos + key.length / 2) % key.length\n";
      $t .= "codechar = (codechar == codechar.toUpperCase()) ? ";
      $t .= "key.substring(pos, pos + 1) : ";
      $t .= "key.substring(pos, pos + 1).toLowerCase()\n";
      $t .= "}\n";
      $t .= "txtRot = txtRot + codechar\n";
      $t .= "}\n";
      if (phpversion() >= "4.2")
         $t .= "return txtRot;\n";
      else
         $t .= "return sCode;\n";
      $t .= "}\n";
   }

   $t .= "function gb_checkForm() {\n";
   if(eregi("true",$plugin_cf['gbook']['captcha'])) {
      $t .= "if (document.gbook.gbcc.value.replace(/\s+/g,'') == '') {\n";
      $t .= "document.gbook.gbcc.style.border = 'red 1px solid';\n";
      $t .= "document.gbook.gbcc.focus();\n";
      $t .= "alert('" . $plugin_tx['gbook']['txt_mandatory_alert'] . "');\n";
      $t .= "return false;\n";
      $t .= "}\n";
   }
   $t .= "if (document.gbook.gbname.value.replace(/\s+/g,'') == '') {\n";
   $t .= "document.gbook.gbname.style.border = 'red 1px solid';\n";
   $t .= "document.gbook.gbname.focus();\n";
   $t .= "alert('" . $plugin_tx['gbook']['txt_mandatory_alert'] . "');\n";
   $t .= "return false;\n";
   $t .= "}\n";
   if((eregi("true",$plugin_cf['gbook']['mandatory_email'])) && (eregi("true",$plugin_cf['gbook']['ask_for_email']))) {
      $t .= "if (document.gbook.gbemail.value.replace(/\s+/g,'') == '') {\n";
      $t .= "document.gbook.gbemail.style.border = 'red 1px solid';\n";
      $t .= "document.gbook.gbemail.focus();\n";
      $t .= "alert('" . $plugin_tx['gbook']['txt_mandatory_alert'] . "');\n";
      $t .= "return false;\n";
      $t .= "}\n";
   }
    if (eregi("true",$plugin_cf['gbook']['ask_for_email'])) {
      $t .= "if ((gb_checkEMA(document.gbook.gbemail.value) == false) && (document.gbook.gbemail.value.replace(/\s+/g,'') != '')) {\n";
      $t .= "document.gbook.gbemail.style.border = 'red 1px solid';\n";
      $t .= "document.gbook.gbemail.focus();\n";
      $t .= "alert('" . $plugin_tx['gbook']['txt_incorrect_email'] . "');\n";
      $t .= "return false;\n";
      $t .= "}\n";
   }
   if((eregi("true",$plugin_cf['gbook']['mandatory_title'])) && (eregi("true",$plugin_cf['gbook']['ask_for_title']))) {
      $t .= "if (document.gbook.gbtitle.value.replace(/\s+/g,'') == '') {\n";
      $t .= "document.gbook.gbtitle.style.border = 'red 1px solid';\n";
      $t .= "document.gbook.gbtitle.focus();\n";
      $t .= "alert('" . $plugin_tx['gbook']['txt_mandatory_alert'] . "');\n";
      $t .= "return false;\n";
      $t .= "}\n";
   }
   $t .= "if (document.gbook.gbmessage.value.replace(/\s+/g,'') == '') {\n";
   $t .= "document.gbook.gbmessage.style.border = 'red 1px solid';\n";
   $t .= "document.gbook.gbmessage.focus();\n";
   $t .= "alert('" . $plugin_tx['gbook']['txt_mandatory_alert'] . "');\n";
   $t .= "return false;\n";
   $t .= "}\n";
   $t .= "}\n";
   
   $t .= "function gb_checkEMA(sEMail) {\n";
   $t .= "var res = false;\n";
   /*
   $t .= "if(typeof(RegExp) == 'function') {\n";
   $t .= "var b = new RegExp('abc');\n";
   $t .= "if(b.test('abc') == true) {a = true;}\n";
   $t .= "}\n";
   $t .= "if(a == true) {\n";
   //$t .= "reg = new RegExp('^([a-zA-Z0-9\\-\\.\\_]+)' + '(\\@)([a-zA-Z0-9\\-\\.]+)' + '(\\.)([a-zA-Z]{2,4})$');\n";
   $t .= "reg = new RegExp('^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[_a-z0-9-]+(\.[_a-z0-9-]+)*(\.([a-z]{2,4}))+$');\n";
   $t .= "res = reg.test(sEMail);\n";
            $t .= "alert('sEMail = '+sEMail);";
            $t .= "alert('res = '+res);";
   $t .= "} else {\n";
   */
   $t .= "res = (sEMail.search('@') >= 1 && sEMail.lastIndexOf('.') > sEMail.search('@') && sEMail.lastIndexOf('.') >= sEMail.length-5)\n";
   //$t .= "}\n";
   $t .= "return(res);\n";
   $t .= "}\n";
   

   //Remaining characters counter
   $t .= "function taLimit(taObj, evt) {\n";
	 $t .= "  if (taObj.value.length>=" . $plugin_cf['gbook']['message_max_chars'] . ") {\n";
	 $t .= "    var keycode = (evt.keyCode==0) ? evt.which : evt.keyCode\n";
	 $t .= "    if (keycode != 8 && keycode != 46) return false;\n"; //allow backspace and delete
   $t .= "  }\n";
	 $t .= "  return true;\n";
   $t .= "}\n";

   $t .= "function taCount(taObj,Cnt) {\n";
   $t .= "	objCnt=createObject(Cnt);\n";
   $t .= "	objVal=taObj.value;\n";
   $t .= "	if (objVal.length>" . $plugin_cf['gbook']['message_max_chars'] . ") objVal=objVal.substring(0," . $plugin_cf['gbook']['message_max_chars'] . ");\n";
   $t .= "	if (objCnt) {";
   $t .= "		if(navigator.appName == \"Netscape\"){\n";
   $t .= "			objCnt.textContent=" . $plugin_cf['gbook']['message_max_chars'] . "-objVal.length;}\n";
   $t .= "		else{objCnt.innerText=" . $plugin_cf['gbook']['message_max_chars'] . "-objVal.length;}\n";
   $t .= "	}\n";
   $t .= "	return true;\n";
   $t .= "}\n";

   $t .= "function createObject(objId) {\n";
   $t .= "	if (document.getElementById) return document.getElementById(objId);\n";
   $t .= "	else if (document.layers) return eval(\"document.\" + objId);\n";
   $t .= "	else if (document.all) return eval(\"document.all.\" + objId);\n";
   $t .= "	else return eval(\"document.\" + objId);\n";
   $t .= "}\n";

   $t .= "function insertText(chrField, chrValue) {\n";
   //IE support
   $t .= "var objField = document.getElementsByName(chrField)[0];\n";  //document.getElementById(chrField);\n";
   $t .= "if (document.selection) {\n";
   $t .= "objField.focus();\n";
   $t .= "sel = document.selection.createRange();\n";
   $t .= "sel.text = chrValue;\n";
   $t .= "}\n";
   //MOZILLA/NETSCAPE/FIREFOX support
   $t .= "else if (objField.selectionStart || objField.selectionStart == '0') {\n";
   $t .= "var startPos = objField.selectionStart;\n";
   $t .= "var endPos = objField.selectionEnd;\n";
   $t .= "objField.value = objField.value.substring(0, startPos) + chrValue + objField.value.substring(endPos, objField.value.length);\n";
   $t .= "} else {\n";
   $t .= "objField.value += chrValue;\n";
   $t .= "}\n";
   $t .= "objField.focus();\n";
   $t .= "taCount(objField,'myCounter');\n"; //TODO: not very nice solution
   $t .= "}\n";

   $t .= "function gb_showWin(fileName) {\n";
   $t .= " var link = 'http://" . $_SERVER['HTTP_HOST'] . "/?" . $_SERVER['QUERY_STRING'] . "&option=' + fileName + '&print';\n";
   $t .= " var infoWin = window.open(link, 'PopupWin', 'location=no, menubar=no, height=350, width=600, resizable=yes, toolbar=no, scrollbars=1');\n";
   $t .= " infoWin.focus();\n";
   $t .= "}\n";

   $t .= "</script>\n";

   if(eregi("true",$plugin_cf['gbook']['show_faq_hint']))
     $t .= "<span style=\"font-size: 115%; color: rgb(190, 0, 45);\">" . $plugin_tx['gbook']['txt_read_faq'] . "</span> <span style=\"font-size: 115%;\">\"<a href=\"./?" . $plugin_cf['gbook']['faq_page_name'] . "\">" . $plugin_tx['gbook']['txt_read_faq_b'] . "</a>\".</span><p/>\n";
   
   if(eregi("true",$plugin_cf['gbook']['new_entries'])) {
      $t .= "<div id=\"anchor1\" style=\"font-size:120%;\"><a href=\"javascript:gb_showDetail(1)\">".$plugin_tx['gbook']['txt_newentry'] . "</a><br>&nbsp;<br></div>";
   } else {
      $t .= $plugin_tx['gbook']['txt_offline_hint'];
   }
   
   if (file_exists($pth['folder']['plugins']."sfilter/index.php")){
      // $t .= "<br>--- SFilter installed ---<br>";
   }

   //$tSpace = "<div style=\"border-top: 3px solid transparent; width: 40%; margin-top: 2px;\"></div>";
   $t .= "\n<div id=\"detail1\" style=\"display: none;\"><hr>";
   $t .= "\n<form name=\"gbook\" onSubmit=\"return gb_checkForm();\" method=\"post\" action=\"?".$su."\">";
   $t .= "\n<table width=\"100%\" cellspacing=\"1\" cellpadding=\"0\">";
   if(eregi("true",$plugin_cf['gbook']['captcha'])) {
      $t .= "\n<tr><td>" . $plugin_tx['gbook']['txt_captcha'];
	  if(eregi("true",$plugin_cf['gbook']['image_captcha'])) {
	     $capParam = 'A';
	     if (eregi("true",$plugin_cf['gbook']['ucase_captcha'])) {
	        $capParam .= 'U';
	     } else {
	        $capParam .= 'L';
	     }
	     $capParam .= $gb_nlines;
	     $t .= " <img style=\"position: relative; top:3px; border: 1px solid #DCE6F0;\" src=\"" . $pth['folder']['plugins'] . $plugin . "/include/qlib/image.php?param=$capParam\" alt=\"captcha\"></td>";
	  } else {
	     $t .= " <strong><script language=\"javascript\" type=\"text/javascript\">document.write(gb_showCC());</script></strong>" . "</td>";
      }
      $t .= "<td><input name=\"gbcc\" type=\"text\" class=\"gbcaptcha\" id=\"textinput\" size=\"8\" maxlength=\"6\"> *</td></tr>";
   }
   $t .= "\n<tr><td>" . $plugin_tx['gbook']['txt_name'] . ": </td>" . "<td style=\"padding-bottom: 1px;\"><input name=\"gbname\" type=\"text\" class=\"gbtextbox\" id=\"textinput\" size=\"40\" maxlength=\"80\"> *</td></tr>";
   if(eregi("true",$plugin_cf['gbook']['ask_for_email'])) {
      $t .= "\n<tr><td>" . $plugin_tx['gbook']['txt_email'] . ": </td>" . "<td><input name=\"gbemail\" type=\"text\" class=\"gbtextbox\" id=\"textinput\" size=\"40\" maxlength=\"80\">";
      if(eregi("true",$plugin_cf['gbook']['mandatory_email'])) $t .= " *";
      $t .= "</td></tr>";
   } else {
      $t .= "\n<tr><td colspan=\"2\"><input name=\"gbemail\" type=\"hidden\" size=\"40\" maxlength=\"80\"></td></tr>";
   }
   if(eregi("true",$plugin_cf['gbook']['ask_for_website'])) {
      $t .= "\n<tr><td>" . $plugin_tx['gbook']['txt_website'] . ": </td>" . "<td><input name=\"gbwebsite\" type=\"text\" class=\"gbtextbox\" id=\"textinput\" size=\"40\" maxlength=\"80\"></td></tr>";
   } else {
      $t .= "\n<tr><td colspan=\"2\"><input name=\"gbwebsite\" type=\"hidden\" size=\"40\" maxlength=\"80\"></td></tr>";
   }
   if(eregi("true",$plugin_cf['gbook']['ask_for_title'])) {
      $t .= "\n<tr><td>" . $plugin_tx['gbook']['txt_title'] . ": </td>" . "<td><input name=\"gbtitle\" type=\"text\" class=\"gbtextbox\" id=\"textinput\" size=\"40\" maxlength=\"80\">";
      if(eregi("true",$plugin_cf['gbook']['mandatory_title'])) $t .= " *";
      $t .= "</td></tr>";
   } else {
      $t .= "\n<tr><td colspan=\"2\"><input name=\"gbtitle\" type=\"hidden\" size=\"40\" maxlength=\"80\"></td></tr>";
   }
   $t .= "\n<tr><td colspan=\"2\" height=\"3\" style=\"font-size:1%;\">&nbsp;</td></tr>" . "\n<tr><td>" . $plugin_tx['gbook']['txt_message'] . ": *</td>";
   $t .= "<td align=\"right\">";
   if(eregi("true",$plugin_cf['gbook']['use_smileys'])) $t .= gb_smileyToolbar();
   $t .= " &nbsp;</td></tr>";
   $t .= "\n<tr><td colspan=\"2\"><textarea rows=\"6\" cols=\"" . $plugin_cf['gbook']['message_width'] . "\" class=\"gbmsgbox\" id=\"textinput\" name=\"gbmessage\" _id=\"gbmessage\" onKeyPress=\"return taLimit(this, event);\" onKeyUp=\"return taCount(this,'myCounter');\"></textarea></td></tr>";
   $t .= "\n<tr><td><small><b><a href=\"javascript:gb_showWin('" . $plugin_tx['gbook']['rules_page'] . "');\">" . $plugin_tx['gbook']['txt_rules'] . "</a></b>";
   if(eregi("true",$plugin_cf['gbook']['allow_bbcode']) && eregi("true",$plugin_cf['gbook']['show_bbcode_hint'])) {
     $t .= " &nbsp; <a href=\"javascript:gb_showWin('" . $plugin_tx['gbook']['bbcode_page'] . "');\">" . $plugin_tx['gbook']['txt_bbcode'] . "</a>";
   }
   $t .= "</small></td>";
   $t .= "<td align=\"right\"><small>" . $plugin_tx['gbook']['max_chars_hint'] . " <b><span id=\"myCounter\">" . $plugin_cf['gbook']['message_max_chars'] . "</span></b></small>&nbsp;&nbsp;</td></tr>";
   $t .= "\n<tr><td colspan=\"2\" height=\"5\" style=\"font-size:1%;\">&nbsp;</td></tr>";
   $t .= "\n<tr><td><input type=\"submit\" style=\"cursor:pointer;background-color:#C1C1C1;border:#444444 1px solid;\" value=\" " . $plugin_tx['gbook']['btn_submit'] . " \">";
   $t .= "&nbsp;&nbsp;<input type=\"button\" style=\"cursor:pointer;background-color:#C1C1C1;border:#444444 1px solid;\" OnClick=\"gb_showDetail(1);\" value=\" " . $plugin_tx['gbook']['btn_cancel'] . " \">";
   $t .= "<td align=\"right\">* = " . $plugin_tx['gbook']['txt_mandatory_hint'] . " &nbsp;</td></tr>";
//-//   $t .= "\n<tr><td colspan=\"2\"><input type=\"hidden\" name=\"gbtoken\" value=\"" . md5(uniqid(mt_rand())) . "\"></td></tr>";
   $t .= "\n</table></form>";
   $t .= "\n<hr><br></div>\n";

   if(is_file($gbfile)){
      $fp = fopen($gbfile, "r");
      $tl = "";
      $lineCount = 0;
      $gbNameArray = array();
      $gbEmailArray = array();
      $gbWebsiteArray = array();
      $gbTimeArray = array();
      $gbDateArray = array();
      $gbTitleArray = array();
      $gbMessageArray = array();
      $gbIpaddrArray = array();
      $gbTStampArray = array();
      $gbname = '';
      $gbemail = '';
      $gbwebsite = '';
      $gbtime = '';
      $gbdate = '';
      $gbtitle = '';
      $gbmessage = '';
      $gbipaddr = '';
      $gbtstamp = '';

      $asrctxt = array (chr(92).chr(34),
                        chr(92).chr(39),
                        chr(10).chr(13),
                        chr(13),
                        chr(10));

      $areptxt = array (chr(34),
                        chr(39),
                        "",
                        "",
                        "");

      while (!feof($fp)) {
         $line = fgets($fp, 4096) . ";";
         @list($gbname,$gbemail,$gbwebsite,$gbtime,$gbdate,$gbtitle,$gbmessage,$gbipaddr,$gbtstamp) = split(";", $line);
         //$line = fgets($fp, 4096);
         //@list($gbname,$gbemail,$gbwebsite,$gbtime,$gbdate,$gbtitle,$gbmessage,$gbipaddr) = split(";", $line);
         if ((empty($gbtitle)) && (empty($gbmessage))) {
            // do nothing
         } else {
            array_push($gbNameArray, str_replace($asrctxt, $areptxt, $gbname));
            array_push($gbEmailArray, str_replace($asrctxt, $areptxt, $gbemail));
            array_push($gbWebsiteArray, $gbwebsite);
            array_push($gbTimeArray, $gbtime);
            array_push($gbDateArray, $gbdate);
            array_push($gbTitleArray, str_replace($asrctxt, $areptxt, $gbtitle));
            array_push($gbMessageArray, str_replace($asrctxt, $areptxt, $gbmessage));
            array_push($gbIpaddrArray, str_replace($asrctxt, $areptxt, $gbipaddr));
            array_push($gbTStampArray, $gbtstamp);

            $lineCount++;
         }


      }
      $lineCount--;
      fclose($fp);
   }

   if (!eregi("&print",$_SERVER['QUERY_STRING'])) {
      $startNum = $lineCount - intval($gbpage-1) * intval($plugin_cf['gbook']['items_per_page']);
      $endNum = $startNum - intval($plugin_cf['gbook']['items_per_page']) + 1.0;
   } else {
      $startNum = $lineCount;
      $endNum = 0;
   }
   if ($endNum < 0) $endNum = 0;
   for ($i = $startNum; $i >= $endNum; $i--) {

      //find admin qualifier if applicable and replace it
      $admin_message = false;
      $titleClass = "gbtitle";
      if(strlen($plugin_cf['gbook']['admin_name_qualifier']) > 0)
      {
        $pos = strpos($gbNameArray[$i], $plugin_cf['gbook']['admin_name_qualifier']);
        if($pos === false)
          $admin_message = false;
        else
        {
          $admin_message = true;
          $titleClass = "gbtitleadmin";
          $gbNameArray[$i] = str_replace($plugin_cf['gbook']['admin_name_qualifier'], "", $gbNameArray[$i]);
        }
      }
      
      if (gb_Modulo($i,2) == 0) {
        if($admin_message == true)
          $lineClass = "gbadminlightline";
        else
          $lineClass = "gblightline";
      } else {
        if($admin_message == true)
          $lineClass = "gbadmindarkline";
        else
          $lineClass = "gbdarkline";
      }
      
      if($plugin_cf['gbook']['allow_bbcode'] == True)
      {
        $gbMessageArray[$i] = bbcode_format($gbMessageArray[$i], false);
      }

      $tm = "";
      $tm .= "<TABLE width=\"100%\" cellpadding=\"4\" cellspacing=\"1\" bgcolor=\"#666666\" border=\"0\">\n";
      if ($gbTitleArray[$i] != '') $tm .= "<TR><TD colspan=\"2\" class=\"" . $titleClass . "\">" . gb_showSmileys($gbTitleArray[$i]) . "</TD></TR>\n";
      $tm .= "<TR>";
      $tm .= "<TD width=\"15%\" class=\"" . $lineClass . "\" valign=\"top\"><div class=\"gbname\" title=\"".$gbNameArray[$i]."\">" . $gbNameArray[$i] . "&nbsp;</div>";
      $tm .= "<span class=\"gbdatetime\">" . $gbDateArray[$i] . ", " . $gbTimeArray[$i] . "</span><br>";
      if (($gbEmailArray[$i] != '') && (eregi("true",$plugin_cf['gbook']['show_email']))) 
        $tm .= "<A href=\""
          . "&#109;&#97;&#105;&#108;&#116;&#111;&#58;" . gb_EncMail($gbEmailArray[$i]) 
          . "\"><IMG src=\"".$imgpath."email.png\" border=\"0\" alt=\"email.png\" title=\"" . gb_EncMail($gbEmailArray[$i]) . "\"></A>&nbsp;";
      if (($gbWebsiteArray[$i] != '') && (eregi("true",$plugin_cf['gbook']['show_website']))) $tm .= "<A href=\"http://" . $gbWebsiteArray[$i] . "\" target=\"_blank\"><IMG src=\"".$imgpath."website.png\" border=\"0\" alt=\"website.png\" title=\"" . $gbWebsiteArray[$i] . "\"></A>&nbsp;";
      if ((eregi("true",$plugin_cf['gbook']['show_ip_addr'])) && (eregi("true",$plugin_cf['gbook']['store_ip_addr'])))
         if ($_SERVER["SERVER_NAME"] == "localhost") {
            $tm .= "<IMG src=\"".$imgpath."machine.png\" border=\"0\" alt=\"machine.png\" title=\"" . $gbIpaddrArray[$i] . " = localhost"  . "\">&nbsp;";
         } else {
            $tm .= "<IMG src=\"".$imgpath."machine.png\" border=\"0\" alt=\"machine.png\" title=\"" . $gbIpaddrArray[$i] . " = " . @gethostbyaddr($gbIpaddrArray[$i]) . "\">&nbsp;";
         }
      $tm .= "</TD>";
      //$gbMessageArray[$i] = gb_showSmileys($gbMessageArray[$i]);
      //$gbMessageArray[$i] = gb_chkQuarantine($gbMessageArray[$i],$gbTStampArray[$i]);
      $tm .= "<TD class=\"" . $lineClass . "\" valign=\"top\"><span class=\"gbmessage\">" . gb_chkQuarantine(gb_showSmileys($gbMessageArray[$i]),$gbTStampArray[$i]) . "&nbsp;</span></TD>";
      //$tm .= "<TD class=\"" . $lineClass . "\" valign=\"top\"><span class=\"gbmessage\">" . gb_showSmileys($gbMessageArray[$i]) . "&nbsp;</span></TD>";
      $tm .= "</TR>\n";
      $tm .= "</TABLE>";
      $tm .= "<br>\n";

      $tl .= $tm;

   }

   $t .= $tl;

   $lineCount++;
   
   if (!eregi("&print",$_SERVER['QUERY_STRING']))
      $t .= gb_DispPageNav(intval($gbpage), $lineCount);

   if(eregi("true",$plugin_cf['gbook']['show_creator'])) {
      $t .= "<div style=\"text-align: center; font-size: 0.75em; display: block\">";
   } else {
      $t .= "<div style=\"text-align: center; font-size: 0.75em; display: none\">";
   }

   $t .= "<br>&nbsp;<br><span style=\"border-top: 1px solid; padding-top: 2px; color:#666666;\">&nbsp;&nbsp;&nbsp;Guestbook plugin, Ver. " . gb_version() . " by ";
   if ($sl == "de")
      { $t .= "<a href=\"http://www.qualifire.de/cmsimple\" target=\"_blank\">"; }
   else
      { $t .= "<a href=\"http://www.qualifire.de/cmsimple/en\" target=\"_blank\">"; }
   $t .= "QualiFIRE</a>, mod " .gb_ModVersion() . " by <a href=\"http://www.pinoccio.webz.cz\" target=\"_blank\">Pinoccio</a>&nbsp;&nbsp;</span>";
   $t .= "</div>";

   $t .= "</div>";
   $t .= "\n<!-- QualiFIREs Guestbook >>GBook<< Code ends here -->\n";

   return $t;
}



function gb_DispPageNav($actPage, $totalLines) {
	GLOBAL $su, $sl, $plugin_cf, $plugin_tx, $pth, $plugin;
	
	$tNav = "";
	$linesPerPage = intval($plugin_cf['gbook']['items_per_page']);
	$actPage = intval($actPage);
	$firstPage = 1;
	$lastPage = gb_Div($totalLines, $linesPerPage);
	$numOfPages = intval($plugin_cf['gbook']['num_of_pages']);

	if (gb_Modulo($totalLines, $linesPerPage) > 0) $lastPage++;
	
	$tNav .= "<div style=\"text-align: center;\">";
	if ($actPage > 1) {
		$tNav .= "<a href=\"?" . $su . "&amp;page=" . intval($firstPage) . "\">" . $plugin_tx['gbook']['lnk_first_page'] . "</a>&nbsp;&nbsp;&nbsp;";
		if(eregi("true",$plugin_cf['gbook']['show_narrowlink'])) 
			$tNav .= "<a href=\"?" . $su . "&amp;page=" . intval($actPage-1) . "\">" . $plugin_tx['gbook']['lnk_prev_page'] . "</a>&nbsp;&nbsp;&nbsp;";
		if($actPage-$numOfPages > $firstPage)
			$tNav .= ".&nbsp;.&nbsp;.&nbsp;&nbsp;&nbsp;";
		for ($i = max($firstPage,$actPage-$numOfPages); $i < $actPage; $i++) 
			$tNav .= "<a href=\"?" . $su . "&amp;page=" . intval($i) . "\">" . intval($i) . "</a>&nbsp;&nbsp;&nbsp;"; 
	}
	
	$tNav .= "<b>" . intval($actPage) . "</b>&nbsp;&nbsp;&nbsp;";
	
	if ($actPage+1 <= $lastPage) {
		for ($i = $actPage+1; $i <= min($lastPage,$actPage+$numOfPages); $i++) 
			$tNav .= "<a href=\"?" . $su . "&amp;page=" . intval($i) . "\">" . intval($i) . "</a>&nbsp;&nbsp;&nbsp;"; 
		if($actPage+$numOfPages < $lastPage)
			$tNav .= ".&nbsp;.&nbsp;.&nbsp;&nbsp;&nbsp;";
		if(eregi("true",$plugin_cf['gbook']['show_narrowlink'])) 
			$tNav .= "<a href=\"?" . $su . "&amp;page=" . intval($actPage+1) . "\">" . $plugin_tx['gbook']['lnk_next_page'] . "</a>&nbsp;&nbsp;&nbsp;";
		$tNav .= "<a href=\"?" . $su . "&amp;page=" . intval($lastPage) . "\">" . $plugin_tx['gbook']['lnk_last_page'] . "</a>";
	}
	$tNav .= "</div>";
	
	return $tNav;
}



function gb_CreateTextCaptcha($lineCount) {
	GLOBAL $su, $sl, $plugin_cf, $plugin_tx, $pth, $plugin;

   $t = "";
   $gbGuestIP = $_SERVER["REMOTE_ADDR"];
   $gbGuestIP = intval(substr($gbGuestIP,strrpos($gbGuestIP,".")+1));
   $gbServerIP = $_SERVER["REMOTE_ADDR"];
   $gbServerIP = intval(substr($gbServerIP,strrpos($gbServerIP,".")+1));
   $t .= gb_MakeCaptChar(date("d")*($gbGuestIP+$lineCount));
   $t .= gb_MakeCaptChar(date("m")*$gbGuestIP*qb_CrossFoot($lineCount));
   $t .= gb_MakeCaptChar(date("z")*$gbGuestIP*$lineCount);
   $t .= gb_MakeCaptChar((date("w")+11)*$gbGuestIP*qb_CrossFoot($lineCount));
   $t .= gb_MakeCaptChar(date("W")*($gbGuestIP+$lineCount));
   $t .= gb_MakeCaptChar($gbGuestIP*$lineCount*$gbServerIP);
   if(!eregi("true",$plugin_cf['gbook']['ucase_captcha']))
      $t = strtolower($t);

   return $t;
}



function gb_EncMail($mailaddr) {

    $cem = "";
    for($i=0; $i<strlen($mailaddr); $i++) {
       if(substr($mailaddr,$i,1)!="@" && substr($mailaddr,$i,1)!=".")
          $cem .= "&#" . ord(substr($mailaddr,$i,1)) . ";";
       else
          $cem .= substr($mailaddr,$i,1);
    }
    return $cem;
}




function gb_MakeCaptChar($nVal) {

   $nSmlVal = gb_Modulo($nVal,36);
   if ($nSmlVal < 10) {
      // 1..9 = '0'..'9'
      $cchar = chr($nSmlVal+48);
   } else {
      // 10..35 = 'A'..'Z'
      $cchar = chr($nSmlVal+55);
   }

   return $cchar;
}



function gb_CountLines ($gbfile){
   $lineCount = 0;
   if(is_file($gbfile)){
      $fp = fopen($gbfile, "r");
      $lineCount = 0;

      while (!feof($fp)) {
         $line = fgets($fp, 4096) . ";";
         if (empty($line)) {
            // do nothing
         } else {
            $lineCount++;
         }


      }
      $lineCount--;
      fclose($fp);
   }
   return $lineCount;
}



function gb_Modulo($vop, $vmod) {
   $nVal = $vop - floor($vop/$vmod)*$vmod;
   return $nVal;
}



function gb_Div($vop, $vmod) {
   $nVal = floor($vop/$vmod);
   return $nVal;
}



function qb_CrossFoot($number) {
   $strNum = (string) $number;

   for ($iCrossFoot=$i=0; $i<strlen($strNum); $i++ ) {
      $iCrossFoot += $strNum{$i};
   }

   return $iCrossFoot;
} 



function gb_rot13($cText) {
    if (phpversion() >= "4.2") 
        return str_rot13($cText);
    else
        return $cText;
}



function gb_conv2Smileys($cText) {
   
   $asrctxt = array (':-))',  
                     ':))',               
                     ':-D',               
                     ':D',               
                     ':-)',               
                     ':)',               
                     '8-)',
                     '8)',               
                     ':P',               
                     ';-)',
                     ';)',               
                     ',-)',               
                     ',)',               
                     '?(',               
                     '8o',               
                     'X(',               
                     ':->',
                     ':>',              
                     ':-(',
                     ':(',
                     ':~(',
                     ';-(',
                     ';(');               

   $areptxt = array (':happy:',
                     ':happy:',
                     ':biggrin:',
                     ':biggrin:',
                     ':smile:',
                     ':smile:',
                     ':cool:',
                     ':cool:',
                     ':tongue:',
                     ':wink:',
                     ':wink:',
                     ':wink:',
                     ':wink:',
                     ':confused:',
                     ':eek:',
                     ':mad:',
                     ':evil:',
                     ':evil:',
                     ':frown:',
                     ':frown:',
                     ':crying:',
                     ':crying:',
                     ':crying:');

   return str_replace($asrctxt, $areptxt, $cText);
}



function gb_showSmileys($cText) {
   GLOBAL $su, $sl, $plugin_cf, $plugin_tx, $pth, $plugin;

   $imgPath = $pth['folder']['plugins'] . "gbook/images/";
   $imgPrefix = "<IMG src=\"" . $imgPath . "emi_";
   $imgPostfix = ".png\" border=\"0\" alt=\"emoticon\">";
   
   $asrctxt = array (':happy:',  
                     ':smile:',
                     ':biggrin:',
                     ':cool:',
                     ':tongue:',
                     ':wink:',
                     ':confused:',
                     ':eek:',
                     ':rolleyes:',
                     ':mad:',
                     ':evil:',
                     ':frown:',
                     ':crying:');               

   $areptxt = array ($imgPrefix."happy".$imgPostfix,
                     $imgPrefix."smile".$imgPostfix,
                     $imgPrefix."biggrin".$imgPostfix,
                     $imgPrefix."cool".$imgPostfix,
                     $imgPrefix."tongue".$imgPostfix,
                     $imgPrefix."wink".$imgPostfix,
                     $imgPrefix."confused".$imgPostfix,
                     $imgPrefix."eek".$imgPostfix,
                     $imgPrefix."rolleyes".$imgPostfix,
                     $imgPrefix."mad".$imgPostfix,
                     $imgPrefix."evil".$imgPostfix,
                     $imgPrefix."frown".$imgPostfix,
                     $imgPrefix."crying".$imgPostfix);

   return str_replace($asrctxt, $areptxt, $cText);
}



function gb_smileyToolbar() {

   $stb = "";
   $stb .= gb_InsertSmilie(':-)','smile'); 
   $stb .= gb_InsertSmilie(':-))','happy'); 
   $stb .= gb_InsertSmilie(':-D','biggrin'); 
   $stb .= gb_InsertSmilie(';-)','wink'); 
   $stb .= gb_InsertSmilie('8-)','cool'); 
   $stb .= gb_InsertSmilie(':P','tongue'); 
   $stb .= gb_InsertSmilie('8o','eek'); 
   $stb .= gb_InsertSmilie(':rolleyes:','rolleyes'); 
   $stb .= gb_InsertSmilie('?(','confused'); 
   $stb .= gb_InsertSmilie(':-(','frown'); 
   $stb .= gb_InsertSmilie(':~(','crying'); 
   $stb .= gb_InsertSmilie('X(','mad'); 
   $stb .= gb_InsertSmilie(':->','evil'); 
   
   return $stb;
}



function gb_InsertSmilie($smiley, $fname) {

    GLOBAL $su, $sl, $plugin_cf, $plugin_tx, $pth, $plugin;

    $imgPath = $pth['folder']['plugins'] . "gbook/images/";
    $smLink = "<A href=\"javascript:insertText('gbmessage','" . $smiley . "');\">";
    $smLink .= "<IMG src=\"" . $imgPath . "emi_" . $fname . ".png\" border=\"0\" alt=\"emoticon\">";
    $smLink .= "</A> ";
    
    return $smLink;
}



function gb_chkQuarantine($cText, $tStamp) {

    GLOBAL $plugin_cf, $plugin_tx;
    
    $dHours = (mktime() - $tStamp) / 3600.0;
    if ($dHours < $plugin_cf['gbook']['quarantine_time']) 
        return "<em>" . sprintf($plugin_tx['gbook']['txt_quarantine_notice'], $plugin_cf['gbook']['quarantine_time']) . "</em>";
    else
        return $cText;
    
}



function gb_chkBlockedIPs ($ipaddr) {

    GLOBAL $plugin_cf;
    
    $ipList = array();
    $ipList = explode( "|", $plugin_cf['gbook']['blocked_IPs'] );
    $retVal = false;
    foreach ($ipList as $key => $ipValue) {
        if (ereg("-",$ipValue) == True) {
        	list($ipstart,$ipend) = explode( "-", $ipValue );
        } else {
        	$ipstart = $ipValue;
        	$ipend = "";
        }

        if (gb_chkIPRange($ipstart,$ipend,$ipaddr))
            $retVal = true;
    }
    return $retVal;

}



function gb_chkIPRange() {
	// args: $lowIP, $highIP, $ipaddr
	$lowIP = func_get_arg(0);
	$highIP = func_get_arg(1);
	if (empty($highIP)) 
		$highIP = $lowIP;
	if (func_num_args() < 3) {
		$ipaddr = $highIP;
		$highIP = $lowIP;
	} else {
		$ipaddr = func_get_arg(2);
	}
	$lowIP = gb_ip2hex($lowIP);
	$highIP = gb_ip2hex($highIP);
	$ipaddr = gb_ip2hex($ipaddr);
	if (($lowIP <= $ipaddr) && ($highIP >= $ipaddr))
		return true;
	else
		return false;
}



function gb_chkBlockedWords($cText) {

    GLOBAL $plugin_cf;
    
    if (eregi($plugin_cf['gbook']['blocked_words'], $cText)) 
        return true;
    else
        return false;
}



function gb_chkBlockedDomains ($ipaddr) {

    GLOBAL $plugin_cf;
    
    $cHostname = @gethostbyaddr($ipaddr);
    if (empty($cHostname))
        $cHostname = "localhost";
        
    if (eregi($plugin_cf['gbook']['blocked_domains'], $cHostname)) 
        return true;
    else
        return false;

}



function gb_chkBlockedCountries ($ipaddr) {

    GLOBAL $plugin_cf;
    
    if (empty($plugin_cf['gbook']['blocked_countries']))
        return false;
        
    $cCountry = ip2country($ipaddr);
    if (eregi($plugin_cf['gbook']['blocked_countries'], $cCountry)) 
        return true;
    else
        return false;

}



function gb_ip2hex($ipaddr) {
	$iprange = explode('.',$ipaddr);
	$iphex = "";
	for($i=0; $i <4; $i++)
		$iphex .= sprintf("%02X",$iprange[$i]);
	return $iphex;
}



function ip2country($ip) {   
    $numbers = preg_split( "/\./", $ip);   
    include("include/ip_files/".$numbers[0].".php");
    $code=($numbers[0] * 16777216) + ($numbers[1] * 65536) + ($numbers[2] * 256) + ($numbers[3]);   
    foreach($ranges as $key => $value){
        if($key<=$code){
            if($ranges[$key][0]>=$code){$two_letter_country_code=$ranges[$key][1];break;}
            }
    }
    if ($two_letter_country_code==""){$two_letter_country_code="00";}
    return $two_letter_country_code;
} 



function gb_RemoveHtml($cText) {

   $asrctxt = array ("'<script[^>]*?>.*?</script>'si",  // Strip out javascript
                 "'<[\/\!]*?[^<>]*?>'si",           // Strip out HTML tags
                 "'([\r\n])[\s]+'",                 // Strip out white space
                 "'&(quot|#34);'i",                 // Replace HTML entities
                 "'&(amp|#38);'i",
                 "'&(lt|#60);'i",
                 "'&(gt|#62);'i",
                 "'&(nbsp|#160);'i",
                 "'&(iexcl|#161);'i",
                 "'&(cent|#162);'i",
                 "'&(pound|#163);'i",
                 "'&(copy|#169);'i",
                 "'&#(\d+);'e");                    // evaluate as php

   $areptxt = array ("",
                  "",
                  "\\1",
                  "\"",
                  "&",
                  "<",
                  ">",
                  " ",
                  chr(161),
                  chr(162),
                  chr(163),
                  chr(169),
                  "chr(\\1)");

   return preg_replace($asrctxt, $areptxt, $cText);
}

function gb_returnContents($what) {
  GLOBAL $pth;
  $base = basename(dirname(__FILE__),"/");
  $file = $pth['folder']['plugins'].$base."/include/" . $what . ".inc";
  if(!$contents = file_get_contents($file))
    return "<html><head><title>Error</title></head><body><br><hr>ERROR: Cannot open file ($file)<hr><br></body></html>";
  return $contents;
}

?>
